Subject: Re: [PATCH] kernel/cpu.c: Add right qualifiers for intel_thermal_interrupt() and cpu_hotplug_pm_sync_init()

From: "Srivatsa S. Bhat" <[email-masked]>
Date: Tue, 15 Nov 2011 11:28:03 +0530

On 11/15/2011 05:32 AM, Yu, Fenghua wrote:
>>> -int cpu_hotplug_pm_sync_init(void)
>>> +static int __init cpu_hotplug_pm_sync_init(void)
>>>  {
>>>  	pm_notifier(cpu_hotplug_pm_callback, 0);
>>
>> pm_notifier() macro will declare a static variable. I agree this won't
>> be any problem functionality-wise. But it doesn't seem elegant to say
>> "throw away the function but keep the static variable".
>> So, if you want to add __init qualifier to this function, I suggest
>> that
>> you declare the static variable outside the function, and call
>> register_pm_notifier() in the function, just to ensure it doesn't
>> obscure
>> things.
>>
> Rmoving __init cpu_hotplug_pm_sync_init() function after boot time and keep the static data defined in pm_notifier() is a normal behavior and normal usage in kernel. Same notifier registration usage function examples are ia64_mca_init() and msic_init() in mrst.c. There are quite a few other similar static data in __init functions usage examples in kernel source code.
> 
> So I would keep the same code in the patch.
>

If that's a well-known practice and is not going to obscure anything,
then I am fine with your patch.

Thanks,
Srivatsa S. Bhat
 
> I'll send an updated patch just to change the title typo.
> 
> Thanks.
> 
> -Fenghua
>